/*============================================================================*

	SUITE:		e-Scrabble
	FILE:		draw_utils.h
	
	COPYRIGHT NOTICE:
	
	Copyright (C) 2001 Players Inc, All Rights Reserved

	THIS MATERIAL IS PROVIDED FOR ACADEMIC USE ONLY, you may modify it
	provided this copyright notice is preserved, however you may not
	redistribute it, or use it for commercial purposes without prior
	written permission of the authors.

	Direct questions, comments, or bug reports to:
	aul@ecf.utoronto.ca
	ticku@ecf.utoronto.ca
	varia@ecf.utoronto.ca	

*============================================================================*/


#ifndef draw_utils_h
#define draw_utils_h

#include <gdk/gdk.h>
#include <glib.h>
#include "scrabble.h"

void draw_my_move ();
void refresh_rack (Tile *, int);
void remove_move (Bmove, gboolean);
void total_refresh_board ();
void incremental_refresh_board ( Bmove );
void redraw_board ();
void draw_tile (GdkPixmap *, Location_Status*, int, int, Tile);
void clear_tile (gboolean, int, int);
void remove_my_rack();

#endif

